// Console-template.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Console-template.h"
#include "Point3D.h"
#include <afxtempl.h>	// ÷ Ŭ   ʿ
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.

		////////////////////////////////////
		// CArray
		////////////////////////////////////
        CArray<Point3D, Point3D&> array;	// Point3D ü   ִ 迭 ü 
        array.SetSize(5);					// ũ 
        for(int i=0; i<5; i++) {
            Point3D pt(i, i*10, i*100);		// x, y, z ǥ ÿ 迭 
            array[i] = pt;					// 迭 pt 
		}

		cout << endl << "Point3D CArray " << endl;
		for(int j=0; j<5; j++) {
            Point3D pt = array[j];
            pt.Show();
        }

		CArray<Point3D, Point3D&> parray;
		parray.Add(Point3D(1,2,3));
		parray.Add(Point3D(10,20,30));
		parray.Add(Point3D(4,5,6));
		parray.Add(Point3D(40,50,60));

		cout << endl << "Point3D CArray  Loop by index:" << endl;
		for(int k = 0; k < parray.GetSize(); k++)
		{
  			Point3D pt = parray.GetAt(k);
	        pt.Show();
		}

		////////////////////////////////////
		// CList
		////////////////////////////////////
		CList<Point3D, Point3D&> list;
        for(int i=0; i<5; i++)
            list.AddTail(Point3D(i, i*10, i*100));

		cout << endl << "Point3D CList " << endl;
		POSITION pos = list.GetHeadPosition();
		while(pos != NULL) {
			Point3D pt = list.GetNext(pos);
			pt.Show();
		}

		cout << endl << "Point3D CList - find" << endl;
		Point3D p1(1, 10, 100);
		pos = list.Find(p1);
		if (pos) {
			Point3D pt = list.GetAt(pos);
			pt.Show();
		}

		////////////////////////////////////
		// CMap
		////////////////////////////////////
		CMap<CString, LPCTSTR, Point3D, Point3D&> map;
        map[CString("")] = array[0];
        map[CString("")] = array[1];
        map[CString("")] = array[2];
        map[CString("")] = array[3];
        map[CString("")] = array[4];

		cout << endl << "CMap - search by key" << endl;
		Point3D mpt;
		if(map.Lookup(CString(""), mpt)) {
            cout << "" << "->";
			mpt.Show();
		}

		cout << endl << "CMap " << endl;
		POSITION mpos = map.GetStartPosition();
		while(mpos != NULL){
			CString strKey;
			map.GetNextAssoc(mpos, strKey, mpt);
			cout << (LPCTSTR)strKey << " -> " ;
			mpt.Show();
		}

		// Dynamic Binding
		Point * p;
		Point p5(Point(1,2));	// using default copy constructor
		Point3D p6(10,20,30);
		p = &p5;
		p->Show();
		p = &p6;
		p->Show();


		// Dynamic Binding - CArray<Point, Point&> CArray<Point*, Point*> 
		CArray<Point, Point&> arr1;
		arr1.Add(Point(10,20));
		arr1.Add(Point(30,40));
		arr1.Add(Point3D(4,5,6));
		arr1.Add(Point3D(7,8,9));

		cout << endl << "CArray<Point, Point&>  Loop by index:" << endl;
		for(int i = 0; i < arr1.GetSize(); i++) {
			arr1[i].Show();
		}

		CArray<Point*, Point*> arr2;
		arr2.Add(new Point(10,20));
		arr2.Add(new Point(30,40));
		arr2.Add(new Point3D(4,5,6));
		arr2.Add(new Point3D(7,8,9));

		cout << endl << "CArray<Point*, Point*>  Loop by index:" << endl;
		for(int i = 0; i < arr2.GetSize(); i++) {
			Point * pt = arr2[i];
			pt->Show();
		}

		// STL Ŀ ..
		vector<Point> arr3;
		arr3.push_back(Point(10,20));
		arr3.push_back(Point(30,40));
		arr3.push_back(Point3D(4,5,6));
		arr3.push_back(Point3D(7,8,9));

		cout << endl << "vector<Point>  Loop by index:" << endl;
		for(int i = 0; i < arr3.size(); i++) {
			arr3[i].Show();
		}

		vector<Point*> arr4;
		arr4.push_back(new Point(10,20));
		arr4.push_back(new Point(30,40));
		arr4.push_back(new Point3D(4,5,6));
		arr4.push_back(new Point3D(7,8,9));

		cout << endl << "vector<Point*>  Loop by index:" << endl;
		for(int i = 0; i < arr4.size(); i++) {
			Point * pt = arr4[i];
			pt->Show();
		}

		// Dynamic Binding - CList<Point*, Point*>
		CList<Point*, Point*> list1;
		list1.AddTail(new Point(10,20));
		list1.AddTail(new Point(30,40));
		list1.AddTail(new Point(50,60));
		list1.AddTail(new Point3D(100,200,300));
		list1.AddTail(new Point3D(400,500,600));

		cout << endl << "Point3D CList " << endl;
		POSITION pos1 = list1.GetHeadPosition();
		while(pos1 != NULL) {
			Point * pt = list1.GetNext(pos1);
			pt->Show();
		}

		// Dynamic Binding - CMap<UINT, UINT, Point*, Point*>
		CMap<int, int, Point*, Point*> map1;
        map1[0] = new Point(10,20);
        map1[1] = new Point(30,40);
        map1[2] = new Point(50,60);
        map1[3] = new Point3D(100,200,300);
        map1[4] = new Point3D(400,500,600);

		cout << endl << "CMap " << endl;
		POSITION pos2 = map1.GetStartPosition();
		while(pos2 != NULL){
			int key;
			Point * pt;
			map1.GetNextAssoc(pos2, key, pt);
			cout << key << " -> ";
			pt->Show();
		}

	}

	return nRetCode;
}
